#include <bits/stdc++.h>
using namespace std;
int main() 
{
ios_base::sync_with_stdio(false);
cin.tie(NULL);
int t,a,b;
cin>>t;
long long niz[75000],niz2[75000],nzd,kraj=0,razlika;
while(t>0)
{
kraj=0;
cin>>a>>b;
for(int i=0;i<a;i++)
{
cin>>niz[i];
if(i>0)
{
razlika=max((niz[i]-niz[i-1]),(niz[i-1]-niz[i]));
if(i>1)
nzd=__gcd(nzd,razlika);
else
nzd=razlika;
}
}
if(nzd==1)
{
for(int i=0;i<b;i++)
cin>>niz2[i];
cout<<0<<endl;
goto end;
}
for(int i=0;i<b;i++)
{
cin>>niz2[i];
if(max((niz2[i]-niz[0]),(niz[0]-niz2[i]))%nzd==0)
kraj=1;
}
if(kraj==1)
cout<<0<<endl;
else
cout<<1<<endl;
end: t--;
}
return 0;
}